
#include <Base/Common/Array2D.hh>

#include <iostream>

using namespace BIAS;
using namespace std;

class foo 
{
public:
  void set(const double d) { data=d; }
  double get() const { return data; }
protected:
  double data;
};

void print(Array2D<foo> &a)
{
  const unsigned nr = a.nrows(), nc = a.ncols();
  cout << nr << " x "<< nc <<" :\n";
  for (unsigned r=0; r<nr; r++){
    for (unsigned c=0; c<nc; c++){
      cout << a(r,c).get() << "\t";
    }
    cout << "\n";
  }
}

int main()
{
  Array2D<foo> array;
  cout << "empty Array2D: ";
  print(array);
  cout << "empty() = "<<boolalpha<<array.empty()<<endl;

  array.resize(2,2);
  cout << "empty Array2D of size 2x2 : ";
  print(array);

  foo f;
  f.set(2.0);
  array.fill(f);
  cout << "filled Array2D of size 2x2 : ";
  print(array);
  

  array.resize(3,3);
  cout << "partially filled Array2D of size 3x3 : ";
  print(array);

  Array2D<foo>::iterator it;
  int i=0;
  for (it = array.begin(); it!=array.end(); it++, i++){
    it->set((double)i);
  }
  cout << "filled Array2D of size 3x3 : ";
  print(array);
  
  cout << "array[1][1] = "<<array[1][1].get()<<endl;

  // should throw
  //cout << array(3,3).get()<<endl;

  return 0;
}
