#include <iostream>
#include <string>

#include <Base/Image/ImageAttributes.hh>

#ifndef BIAS_HAVE_IMAGEMAGICKLIB
#  error BIAS_HAVE_IMAGEMAGICKLIB not defined. Recompile BIAS with ImageMagick
#endif

/**
 @example ExampleImageAttributes.cpp
 Access Image attrobute susing ImageMagick, 
 e.g. timestamp, focal length, shutter times automatically written to Jpeg header by digital cameras. 
 @author Jan Woetzel
*/


using namespace std;
using namespace BIAS;


void usage(int argc, char** argv) {
    cerr<<"started ";
    if (argc>0) cerr<<argv[0]<<endl;
    cerr<<"usage: "<<endl
        <<argv[0]<<" <image-filename.jpg>"<<endl;
}


int main(int argc, char** argv)
{ 
  if (argc!=2) {
    usage(argc, argv);
    return 0;
  };
  
  string filename("");
  BIASASSERT(argc>1);
  filename=argv[1];
  
  ImageAttributes attr;
  attr.InitExifTags();
  attr.Read(filename);
  cout<<attr;
}
