
// Jan Woetzel

#ifndef _RGBA_hh_
#define _RGBA_hh_

#include "bias_config.h" 
#include <Base/Math/Vector4.hh>


/// predefined colors
/// opaque = not transparent
#define RGBAuc_WHITE_OPAQUE BIAS::RGBAuc(255,255,255, 255)

/// semi transparent
#define RGBAuc_WHITE_SEMI   BIAS::RGBAuc(255,255,255, 128)



namespace BIAS {
	/** @class RGBAuc 
	@ingroup g_math
	@brief class RGBAuc is asynonym for a Vector4 of corerct type
	@author Jan Woetzel	**/
	typedef BIAS::Vector4<unsigned char> RGBAuc;

	/** @class RGBAf 
	@ingroup g_math
	@brief class RGBAf is asynonym for a Vector4 of correct type
	@author Jan Woetzel	**/
	typedef BIAS::Vector4<float> RGBAf;

	/** @class RGBAd 
	@ingroup g_math
	@brief class RGBAd is asynonym for a Vector4 of correct type 
	@author Jan Woetzel	**/
	typedef BIAS::Vector4<double> RGBAd;

} // namespace BIAS
#endif

