# - Find Graphic Remedy (GREMEDY) gDEBugger installation 
# This module finds headers and libs for gDEBugger, 
# an OpenGL debugger/profiler, see
# http://www.gremedy.com/
#
#  GDEBUGGER_FOUND            = system has gDEBugger
#  GDEBUGGER_LIBRARIES        = 
#  GDEBUGGER_INCLUDE_DIRS     = where to find "wx/wx.h" and "wx/setup.h"
#  WXWINDOWS_LINK_DIRECTORIES = 
#
# AUTHOR
# Jan Woetzel <http://www.mip.informatik.uni-kiel.de/~jw> (09/2006)


IF (WIN32)

  SET (GDEBUGGER_POSSIBLE_ROOT_DIRS
    ${GDEBUGGER_ROOT_DIR}
    $ENV{GDEBUGGER_ROOT_DIR}
    $ENV{GDEBUGGER_DIR}
    $ENV{GDEBUGGER_HOME}
    $ENV{GDEBUGGER}
    $ENV{GREMEDY}
    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Graphic Remedy\\gDEBugger;InstallationDirectory]"
    "$ENV{ProgramFiles}/Graphic Remedy"
    )

  FIND_PATH(GDEBUGGER_EXTENSIONS_INCLUDE_DIR
    NAMES GRemdeyExtensions.h #GRemedyExtensions.h
    PATHS ${GDEBUGGER_POSSIBLE_ROOT_DIRS}
    PATH_SUFFIXES include inc "Graphic Remdey Extensions" "Graphic Remedey Extensions"
    DOC "gDEBugger extension header"
    )

  FIND_PATH(GDEBUGGER_EGL_INCLUDE_DIR
    NAMES GLES/egl.h
    PATHS ${GDEBUGGER_POSSIBLE_ROOT_DIRS}
    PATH_SUFFIXES include inc
    DOC "gDEBugger extension header"
    )

  FIND_LIBRARY(GDEBUGGER_GLES_CM_LIBRARY
    NAMES libGLES_CM GLES_CM
    PATHS ${GDEBUGGER_POSSIBLE_ROOT_DIRS}
    PATH_SUFFIXES lib arch
    DOC "gDEBugger GLES_CM library"
    )


  # we want only the c/c++ OpenGL extension header for now.
  IF   (GDEBUGGER_INCLUDE_DIR)
    SET(GDEBUGGER_INCLUDE_DIR "${GDEBUGGER_EXTENSIONS_INCLUDE_DIR}")
    SET(GDEBUGGER_FOUND 1)
  ENDIF(GDEBUGGER_INCLUDE_DIR)

  MARK_AS_ADVANCED(
    GDEBUGGER_INCLUDE_DIR
    GDEBUGGER_EXTENSIONS_INCLUDE_DIR
    GDEBUGGER_GLES_CM_LIBRARY
    GDEBUGGER_EGL_INCLUDE_DIR
    )

ENDIF(WIN32)


# ==========================================
IF(NOT GDEBUGGER_FOUND)
  # make FIND_PACKAGE friendly
  IF(NOT GDEBUGGER_FIND_QUIETLY)
    IF(GDEBUGGER_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "GDEBUGGER required, please specify it's location.")
    ELSE(GDEBUGGER_FIND_REQUIRED)
      MESSAGE(STATUS       "ERROR: GDEBUGGER was not found.")
    ENDIF(GDEBUGGER_FIND_REQUIRED)
  ENDIF(NOT GDEBUGGER_FIND_QUIETLY)
ENDIF(NOT GDEBUGGER_FOUND)
