
IF(WIN32)
  ###########################  Windows ###############################  
  SET(OPENSCENEGRAPH_POSSIBLE_ROOT_PATHS 
    "$ENV{EXTERN_LIBS_DIR}/OpenSceneGraph"
    )
  
  FIND_PATH(OPENSCENEGRAPH_ROOT_DIR include/osg/Node
    ${OPENSCENEGRAPH_POSSIBLE_ROOT_PATHS}
    )

  IF(OPENSCENEGRAPH_ROOT_DIR)    
    SET(OPENSCENEGRAPH_INCLUDE_DIR "${OPENSCENEGRAPH_ROOT_DIR}/include")
    SET(OPENSCENEGRAPH_LINK_DIR "${OPENSCENEGRAPH_ROOT_DIR}/lib")
    SET(OPENSCENEGRAPH_LINK_FLAGS "")
    SET(OPENSCENEGRAPH_LIBRARIES 
      debug osgd optimized  osg
      debug osgDBd optimized  osgDB
      debug osgFXd  optimized osgFX
     debug osgGAd  optimized osgGA
     debug  osgParticled  optimized osgParticle
     debug  osgSimd  optimized osgSim
     debug  osgTextd  optimized osgText
     debug   osgUtild optimized osgUtil
     debug   osgViewerd optimized osgViewer
     debug   OpenThreadsd optimized OpenThreads
      )
    SET(OPENSCENEGRAPH_FOUND TRUE)
  ELSE(OPENSCENEGRAPH_ROOT_DIR)
    SET(OPENSCENEGRAPH_FOUND FALSE)    
  ENDIF(OPENSCENEGRAPH_ROOT_DIR)    
ELSE(WIN32)
  ###########################  Linux ###############################
  INCLUDE(/usr/share/cmake-2.4/Modules/UsePkgConfig.cmake)
  PKGCONFIG(openscenegraph OPENSCENEGRAPH_INCLUDE_DIR 
    OPENSCENEGRAPH_LINK_DIR OPENSCENEGRAPH_LINK_FLAGS OPENSCENEGRAPH_CFLAGS)

  IF(OPENSCENEGRAPH_INCLUDE_DIR)
    SET(OPENSCENEGRAPH_FOUND ON)
    # may be we should remove all the -l prefixes from the flags?    
    SET(OPENSCENEGRAPH_LIBRARIES ${OPENSCENEGRAPH_LINK_FLAGS})
  ELSE(OPENSCENEGRAPH_INCLUDE_DIR)
    SET(OPENSCENEGRAPH_FOUND OFF)
  ENDIF(OPENSCENEGRAPH_INCLUDE_DIR)
  
ENDIF(WIN32)
#MESSAGE("OPENSCENEGRAPH_LINK_DIR: ${OPENSCENEGRAPH_LINK_DIR}")
#MESSAGE("OPENSCENEGRAPH_INCLUDE_DIR: ${OPENSCENEGRAPH_INCLUDE_DIR}")
#MESSAGE("OPENSCENEGRAPH_LINK_FLAGS: ${OPENSCENEGRAPH_LINK_FLAGS}")
#MESSAGE("OPENSCENEGRAPH_CFLAGS: ${OPENSCENEGRAPH_CFLAGS}")
#MESSAGE("OPENSCENEGRAPH_LIBRARIES: ${OPENSCENEGRAPH_LIBRARIES}")
