/// demonstrate finding of asymmetric checker/chessboard.
/// Jan Woetzel
#include <Base/Common/W32Compat.hh>
#include <math.h>

#include <vector>
#include <string>
#include <iostream>
#include <Base/Debug/Error.hh>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh>
#include <Base/Common/FileHandling.hh>

#include <FeatureDetector/CheckerboardDetector.hh> // < test this one


using namespace std;
using namespace BIAS;


// usage: ExampleCheckerboard <filename> <inner_xCorners> <inner_yCorners>

// ---------------
int main(int argc, char** argv)
{
  // params
  string imgFilename(BIAS_TESTS_DATA "chess7x4_002.jpg");
  unsigned int xCorners(7), yCorners(4); //< inner corners

  // parse args
  if (argc>1)
    imgFilename = argv[1];
  if (argc>2)
    xCorners = atoi(argv[2]);
  if (argc>3)
    xCorners = atoi(argv[3]);


  BIAS::Image<unsigned char> img; //< image to work on

  cout<<"loading "<<imgFilename<<endl;
  if (ImageIO::Load(imgFilename, img)!=0) 
  {
    BIASERR("Could not load "<<imgFilename); BIASBREAK;
    return -1;
  }

  // storage for detected positions: 
  vector< pair<float,float> >  coords;

  //
  // MIP: detect chessboard demonstration 
  //
  int result = CheckerboardDetector::Compute(img, xCorners , yCorners, coords, true);

  if (result!=0){
    BIASERR("could not detect!");
    return -1;
  }

  // print result coords
  for (unsigned int i=0; i<coords.size(); i++){
    cout<<i<<". : "<<coords[i].first<<", "<<coords[i].second<<endl;
  }

  return 0;
}

