#include <Geometry/ProjectionParametersIO.hh>
#include <iostream>

using namespace BIAS;
using namespace std;

int main (int argc, char* argv[])
{
  CameraData cd, cd2;
  vector<CameraData> vcd, vcd2;
#ifdef BIAS_HAVE_XML2
  if (argc<2) {
    cout <<"no file given, using some build-in data"<<endl;
    ProjectionParametersIO::SetData_OMNITECH_ORIFL_190_3(cd);
  }
  else {
    if (ProjectionParametersIO::ReadCameraData(argv[1],cd)<0) {
      cout << "Error reading file:" << argv[1] << endl;
    } else {
      cout << "Read file:" << argv[1] << endl;
    }
  }
  
  if (argc<3) {
    cout <<"no rig file given, using some build-in data"<<endl;
    ProjectionParametersIO::SetData_DummyRig(vcd);
  } else {
    BIASASSERT(argc>1);
    if (ProjectionParametersIO::ReadRigData(argv[2],vcd)<0) {
      cout << "Error reading file:" << argv[1] << endl;
    } else {
      cout << "Read file:" << argv[1] << endl;
    }
  }
  cout << "File contents: ";
  if (argc>1) 
    cout<<argv[1]  ;
  cout << "-------------------" << endl;
  cout << cd;
  ProjectionParametersIO::WriteCameraData("CamDataTest.xml",cd);
  cout <<"CamDataTest.xml created" << endl;

  ProjectionParametersIO::ReadCameraData("CamDataTest.xml",cd2);
  cout << "File contents: " << "CamDataTest.xml" 
       << "-------------------" << endl;
  cout << cd2;
  ProjectionParametersIO::WriteCameraData("CamDataTestRewrite.xml", cd2);
  cout <<"CamDataTestRewrite.xml created" << endl;

  cout << "File contents: ";
  if (argc>2) 
    cout<<argv[2];  
  cout<< "-------------------" << endl;
  cout << vcd;
  ProjectionParametersIO::WriteRigData("RigDataTest.xml",vcd);
  cout <<"RigDataTest.xml created" << endl;

  ProjectionParametersIO::ReadRigData("RigDataTest.xml",vcd2);
  cout << "File contents: " << "RigDataTest.xml"  
       << "-------------------" << endl;
  cout << vcd2;
  ProjectionParametersIO::WriteRigData("RigDataTestRewrite.xml", vcd2);
  cout <<"RigDataTestRewrite.xml created" << endl;
#endif
  return 0;  
}
