#ifdef WIN32
#  pragma warning (disable: 4005) // for VS8 + WX
#endif

#include "SimpleGLFrame.hh"

using namespace std;
using namespace BIAS;

// initialize globals 
int BIASSimpleGLApp_EXPORT BIAS::SimpleGLFrame::mode=0;
int BIASSimpleGLApp_EXPORT BIAS::SimpleGLFrame::label=0;
int BIASSimpleGLApp_EXPORT BIAS::SimpleGLFrame::flag=0;


// --------------------------------------------------------
BEGIN_EVENT_TABLE(BIAS::SimpleGLFrame, wxFrame)
EVT_MENU(ID_QUIT,        SimpleGLFrame::OnQuit)
EVT_MENU(ID_ABOUT,       SimpleGLFrame::OnAbout)
EVT_MENU(ID_MODE_PLUS,   SimpleGLFrame::OnInteraction)
EVT_MENU(ID_MODE_MINUS,  SimpleGLFrame::OnInteraction)
EVT_MENU(ID_LABEL_PLUS,  SimpleGLFrame::OnInteraction)
EVT_MENU(ID_LABEL_MINUS, SimpleGLFrame::OnInteraction)
EVT_MENU(ID_FLAG_PLUS,   SimpleGLFrame::OnInteraction)
EVT_MENU(ID_FLAG_MINUS,  SimpleGLFrame::OnInteraction)
END_EVENT_TABLE() 
// --------------------------------------------------------

BIAS::SimpleGLFrame::SimpleGLFrame(const wxString & title,
                                   const wxPoint & pos, const wxSize & size)
                                   :wxFrame((wxFrame *) NULL, -1, title, pos, size)
                                   ,pCanvas(NULL)
{
  // Create a simple top Menu
  wxMenu *menuFile = new wxMenu;
  menuFile->Append(ID_ABOUT, _T("&About...") );
  menuFile->AppendSeparator();
  menuFile->Append(ID_QUIT, _T("E&xit") );

  wxMenu *menuInteraction = new wxMenu;
  menuInteraction->Append(ID_MODE_PLUS,  _T("&1 mode++...\tCtrl-1") );
  menuInteraction->Append(ID_MODE_MINUS, _T("&2 mode--...\tCtrl-2") );
  menuInteraction->Append(ID_LABEL_PLUS, _T("&3 label++...\tCtrl-3") );
  menuInteraction->Append(ID_LABEL_MINUS,_T("&4 label--...\tCtrl-4") );
  menuInteraction->Append(ID_FLAG_PLUS,  _T("&5 flag++...\tCtrl-5") );
  menuInteraction->Append(ID_FLAG_MINUS, _T("&6 flag--...\tCtrl-6") );

  menuInteraction->AppendSeparator();

  wxMenuBar *menuBar = new wxMenuBar;
  menuBar->Append(menuFile, _T("&File") );
  menuBar->Append(menuInteraction, _T("&Interaction") );
  SetMenuBar(menuBar);

  // Create a simple bottom status bar 
  CreateStatusBar(1);

  // Canvas to test: 
  pCanvas = new SimpleGLCanvas(this);

  // put them into sizers: 
  wxBoxSizer *sizer = new wxBoxSizer(wxHORIZONTAL);
  sizer->Add(pCanvas, 1, wxEXPAND | wxALL);
#if wxCHECK_VERSION(2, 6, 2)
  sizer->AddSpacer(4);	// available in 2.6.2 but not 2.4.2 (JW)
#endif

  // limit min. size:
  sizer->SetItemMinSize(pCanvas, 500, 400);
  sizer->SetSizeHints(this);

  // set sizer and triggers Layout()
  SetSizerAndFit(sizer);
}


void BIAS::SimpleGLFrame::OnQuit(wxCommandEvent &)
{
  Close(TRUE);
}


void BIAS::SimpleGLFrame::OnAbout(wxCommandEvent &)
{
  wxString title( _T("About") );
  stringstream msg;
  msg << "About - " << FUNCNAME << "\n";
  msg << "author: Jan Woetzel (c) 2003-2006\n";
  msg << "build: " << __DATE__ << " " << __TIME__ << "\n";
  msg << "from " << __FILE__ << "\n";
  msg << "GUI using: " << wxVERSION_STRING << "\n";
  msg << "\n";
  COUT(msg.str());
  wxMessageBox(wxString(msg.str().c_str(), wxConvUTF8), title, wxICON_INFORMATION | wxOK);
}

void BIAS::SimpleGLFrame::OnInteraction(wxCommandEvent & event){
  switch(event.GetId()){
    case ID_MODE_PLUS:   mode++;   break;
    case ID_MODE_MINUS:  mode--;   break;
    case ID_LABEL_PLUS:   label++; break;
    case ID_LABEL_MINUS:  label--; break;
    case ID_FLAG_PLUS:   flag++;   break;
    case ID_FLAG_MINUS:  flag--;   break;

      //default:;
  }
  stringstream ss;
  ss<<"mode="<<mode<<" label="<<label<<" flag="<<flag<<" ";
  cout<<ss.str()<<endl;
  SetStatusText( wxString(ss.str().c_str(), wxConvUTF8) );
}
