#ifndef _bias_wx_glcanvas_h_
#define _bias_wx_glcanvas_h_



/** 
\brief wrapper for <wx/glcanvas.h> to include glxew soon enough
\author: Jan Woetzel
*/

#include <bias_config.h>
#include <Gui/biasgl.h>

#if !defined(BIAS_HAVE_WXWIDGETS) && !defined(MIP_HAVE_WXWIDGETS)
#  error You need WX to compile. Please recompile BIAS and/or MIP with USE_WXWIDGETS.
#else // WX

// order is mandatory: include glew first to avoid redefinitions ! (JW)
// wxglcanvas includes glx.h, 
// thus we must include glxew first to avoid conflict in glew case
#if defined(BIAS_HAVE_GLEW) || defined(MIP_HAVE_GLEW) 
#  if !defined(WIN32)
#    include <GL/glxew.h>
#    define __glx_h__
#    define GLX_H
#  endif // GLEW 
#endif // Linux


#include <wx/glcanvas.h> 

// check defines from wx/setup.h implicitly
#if defined(wxUSE_GLCANVAS) && wxUSE_GLCANVAS
// OK, wx compiled in configuration with wxgl lib
#else
#  error wx has not been compiled with wxUSE_GLCANVAS=1. Please set wx/setup.h wxUSE_GLCANVAS=1 and recompile WX.
#endif


#endif //WX



#endif // _bias_wx_glcanvas_h_ 
// DO NOT ADD CODE AFTER THIS LINE

