#include <iostream>
#include <Base/Image/ImageIO.hh>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageConvert.hh>
#include <Image/AffineMapping.hh>

using namespace BIAS;
using namespace std;



int main(int argc, char** argv ) {
  
  if (argc < 2) {
    BIASERR("need 1 image path as param!");
    BIASABORT;
  }
  
  Image<unsigned char> image, scaledImage;
  AffineMapping<unsigned char, unsigned char> mapper;
  
  if (ImageIO::Load(argv[1], image) != 0) {
    BIASERR("ooops! could not load image!");
    BIASABORT;
  }
  
  ImageIO::Save("before_mapping.mip", image);
  
  // scale image
  double s = 2.0;
  scaledImage.Init((unsigned int)rint(image.GetWidth() / s), 
                   (unsigned int)rint(image.GetHeight() / s),
                   image.GetChannelCount());
  mapper.SetAffineTransformation(s,
                                 0.0,
                                 0.0,
                                 s,
                                 0.0,
                                 0.0);
  mapper.Map(image, scaledImage, MapTrilinear);
  
  ImageIO::Save("after_mapping.mip", scaledImage);
  
  return 0;
}
