/* This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003, 2004    (see file CONTACTS for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/
#include <Image/Camera.hh>

using namespace BIAS;
using namespace std;

/// @author woelk 10/2007 (c) www.vision-n.de 
int main(int argc, char *argv[])
{
  PMatrix P;
  for (int i=0; i<12; i++)
    P.GetData()[i] = (double)i;
  Camera<unsigned char> cam;
  cam.Init(640, 480, 1);
  cam.SetP(P);
  cam.UpdateMetaData();

  ImageBase *ib = &cam;
  
  Camera<unsigned char> *cam2 = dynamic_cast<Camera<unsigned char> *>(ib);
  if (!cam2){
    BIASERR("error in dynamic cast");
    return -1;
  }
  
  cam2->ParseMetaData();
  cout << "cam2->P: "<<cam2->GetP()<<endl;

  return 0;
}
