#include <wx/wx.h>
#include <Gui/ConsoleRedirectIO.hh>
#include "ExampleMixtureOfGaussiansFrame.hh"
#include "ExampleMixtureOfGaussiansApp.hh"

using namespace BIAS;

bool ExampleMixtureOfGaussiansApp::OnInit()
{
  // Open console for windows
  ConsoleRedirectIO();

  // create main frame
  ExampleMixtureOfGaussiansFrame *mainFrame;
  mainFrame = new ExampleMixtureOfGaussiansFrame(AsciiToWx("Mixture of Gaussians"), wxPoint(50,50),
                                 wxSize(400,340));
  
  // necessary for high resolution on small monitors (hackish...)
  mainFrame->SetSizeHints(640,480,1800,1600);

  // initialize cameras and try to open them
  mainFrame->InitCamera();
  mainFrame->CreateMenu();
  
  // create main windows
  mainFrame->Show(true);
  SetTopWindow(mainFrame);
  
  return true;
}

IMPLEMENT_APP(ExampleMixtureOfGaussiansApp) 
