#include "DPPanTiltControlDialog.hh"

using namespace BIAS;
using namespace std;

DPPanTiltControlDialog::
DPPanTiltControlDialog(wxFrame *parent, wxWindowID id, const wxString &title )
        : wxDialog(parent, id, title, wxDefaultPosition, wxDefaultSize,
                   wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER)
{


  wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL );
  
  CenterOnScreen();

  wxBoxSizer *button_sizer_top = new wxBoxSizer( wxHORIZONTAL );
  wxBoxSizer *button_sizer_middle = new wxBoxSizer( wxHORIZONTAL );
  wxBoxSizer *button_sizer_bottom = new wxBoxSizer( wxHORIZONTAL );
  wxBoxSizer *button_sizer_end = new wxBoxSizer( wxHORIZONTAL );
  
  button_sizer_top->Add(
     new wxButton( this, ID_UP, wxT("Up") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10
  button_sizer_middle->Add(
     new wxButton( this, ID_LEFT, wxT("Left") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10
  button_sizer_middle->Add(
     new wxButton( this, ID_RIGHT, wxT("Right") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10
  
  button_sizer_middle->Add(
     new wxButton( this, ID_AUTO, wxT("Auto") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10

  button_sizer_bottom->Add(
     new wxButton( this, ID_DOWN, wxT("Down") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10
  button_sizer_end->Add(
     new wxButton( this, ID_RESET, wxT("Soft Reset") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10
  button_sizer_end->Add(
     new wxButton( this, ID_RESETFULL, wxT("Full Reset") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10
 button_sizer_end->Add(
     new wxButton( this, ID_DPQUIT, wxT("OK") ),
     0,           // make horizontally unstretchable
     wxALL,       // make border all around (implicit top alignment)
     10 );        // set border width to 10


  topsizer->Add(
     button_sizer_top,
     0,                // make vertically unstretchable
     wxALIGN_CENTER ); // no border and centre horizontally
 topsizer->Add(
     button_sizer_middle,
     0,                // make vertically unstretchable
     wxALIGN_CENTER ); // no border and centre horizontally
 topsizer->Add(
     button_sizer_bottom,
     0,                // make vertically unstretchable
     wxALIGN_CENTER ); // no border and centre horizontally
 topsizer->Add(
     button_sizer_end,
     0,                // make vertically unstretchable
     wxALIGN_CENTER ); // no border and centre horizontally


  SetSizer( topsizer );      // use the sizer for layout

  topsizer->SetSizeHints( this );   // set size hints to honour minimum size
}

BEGIN_EVENT_TABLE(DPPanTiltControlDialog, wxDialog)
  EVT_BUTTON(ID_LEFT,DPPanTiltControlDialog::OnLeft)
  EVT_BUTTON(ID_RIGHT,DPPanTiltControlDialog::OnRight)
  EVT_BUTTON(ID_UP,DPPanTiltControlDialog::OnUp)
  EVT_BUTTON(ID_DOWN, DPPanTiltControlDialog::OnDown)
  EVT_BUTTON(ID_AUTO, DPPanTiltControlDialog::OnAutoMove)
  EVT_BUTTON(ID_RESET, DPPanTiltControlDialog::OnReset) 
  EVT_BUTTON(ID_RESETFULL, DPPanTiltControlDialog::OnResetFull)
  EVT_BUTTON(ID_DPQUIT, DPPanTiltControlDialog::OnQuit)
END_EVENT_TABLE()


void DPPanTiltControlDialog::SetDPControl(DPPanTiltControl *dpControl)
{
  pDpPanTiltControl_ = dpControl;
  pDpPanTiltControl_->SetMode(ABSOLUTEMODE);  
  pDpPanTiltControl_->SetSpeed(MAXSPEED,MAXSPEED);
  pDpPanTiltControl_->SetPosition(0,0);
}


void DPPanTiltControlDialog::OnLeft(wxCommandEvent& WXUNUSED(event))
{  
 
  pDpPanTiltControl_->MoveLeft(100);
}

void DPPanTiltControlDialog::OnRight(wxCommandEvent& WXUNUSED(event))
{
  pDpPanTiltControl_->MoveRight(100);
}
void DPPanTiltControlDialog::OnUp(wxCommandEvent& WXUNUSED(event))
{
  pDpPanTiltControl_->MoveUp(100);
}
void DPPanTiltControlDialog::OnDown(wxCommandEvent& WXUNUSED(event))
{
  pDpPanTiltControl_->MoveDown(100);
}


void DPPanTiltControlDialog::OnAutoMove(wxCommandEvent& WXUNUSED(event))
{  
  cout<<"AutoMove"<<endl;
  pDpPanTiltControl_->StartCircularMovement();
}

void DPPanTiltControlDialog::OnResetFull(wxCommandEvent& WXUNUSED(event))
{
  reset_ptu();
}

void DPPanTiltControlDialog::OnReset(wxCommandEvent& WXUNUSED(event))
{
   pDpPanTiltControl_->ResetPanTiltUnit();
}
void DPPanTiltControlDialog::OnQuit(wxCommandEvent& WXUNUSED(event))
{
  pDpPanTiltControl_->SetMode(SPEEDMODE);
  Close(TRUE);
}
