#include <Base/Common/BIASpragma.hh>
#include <PanTilt/DPPanTiltControl.hh>
#ifdef WIN32
  #include <conio.h>
#else // WIN32
  #include <ncurses.h>
#endif // WIN32
#include <PanTilt/Control.hh>
#include <PanTilt/ManualControl.hh>
#include <PanTilt/AutoControl.hh>

using namespace std;
using namespace BIAS;

int main (int argc, string *argv){

  
#ifndef WIN32
  initscr();
  keypad(stdscr, true);
  noecho();
  cbreak(); 
  mvprintw(0,0,"PanTilt Manual Control");
  mvprintw(2,0,"use w,s,a,d to steer camera. <space> q exits.");
#endif // WIN32

  // create a new factory...
	ControlFactory *cf;
	cf = new ManualControlFactory();
	// ... which should build automatic controls
	// cf = new AutoControlFactory();
	// factory should produce such control
	Control *control = cf->create();
	// start up the produced control
	control->startControl();
	
	bool loop = true;

	while (loop) {
		char c = getch();
		switch(c) {
			case 'e':
				control->stopControl();
				break;
			case 'r':
				control->resumeControl();
				break;
			case 'q':
				control->stopControl();
				loop = false;
				break;
		}
	}

#ifndef WIN32
	endwin();
#endif // WIN32

	// shutdown connection to ptu
	delete control;
	return 0;
}
