//#include <iostream>
#include <Base/Common/BIASpragma.hh>
#include <PanTilt/DPPanTiltControl.hh>
#ifdef WIN32
  #include <conio.h>
#else // WIN32
  #include <ncurses.h>
#endif // WIN32
#include <fstream>
#include "Control.hh"
#include "ManualControl.hh"

using namespace std;
using namespace BIAS;

ManualControl::ManualControl() {
	
}

void ManualControl::startControl() {
	int min_pan = -2000;
	int max_pan = 2000;
	int min_tilt = -900;
	int max_tilt = 700;
	int pan_mod = 100;
	int tilt_mod = 100;

	Control::ptControl.SetMode(ABSOLUTEMODE);
	await_completion();
	Control::ptControl.SetSpeed(MAXSPEED/4,MAXSPEED/4);

	ofstream myfile;
	myfile.open("ptu_data.txt", ios::out);

	int key=-1;
	bool looping = true;
	bool move_pt;
	while(looping) {
		key = getch();
		move_pt = false;
		switch (key) {
			case 'a':
				cur_pan+=pan_mod;
				if (cur_pan > max_pan)
					cur_pan = max_pan;
				move_pt = true;
			break;
			case 'd':
				cur_pan-=pan_mod;
				if (cur_pan < min_pan)
					cur_pan = min_pan;
				move_pt = true;
			break;
			case 'w':
				cur_tilt+=tilt_mod;
				if (cur_tilt > max_tilt)
					cur_tilt = max_tilt;
				move_pt = true;
			break;
			case 's':
				cur_tilt-=tilt_mod;
				if (cur_tilt < min_tilt)
					cur_tilt = min_tilt;
				move_pt = true;
			break;
			case 'o':
				Control::ptControl.SetSpeed(MAXSPEED/4, MAXSPEED/4);
				for (int i=0;i<=10;i+=2) {
					int tilt = -500+(tilt_mod*i);
					key = getch();
					if (key == 'q')
						break;
					Control::ptControl.SetPosition(1800, tilt);
					key = getch();
					if (key == 'q')
						break;
					Control::ptControl.SetPosition(-1800, tilt);
				}
				Control::ptControl.SetSpeed(MAXSPEED, MAXSPEED);
				move_pt=true;
			break;
			case ' ':
				looping = false;
				myfile.close();
			break;
		}
		if (move_pt) {
			Control::ptControl.SetPosition(cur_pan,cur_tilt);
			await_completion();
			double p,t;
      			Control::getPositionDegrees(p,t);
      			myfile << p << " ";
      			myfile << t << endl;
#ifdef WIN32
			cout << "PAN: " << cur_pan << " TILT: " << cur_tilt << endl;
			cout << "PAN: " << p << " TILT: " << t << endl;
#else
			mvprintw(4,0, "PAN: %d   Tilt: %d           \n", cur_pan, cur_tilt);
      mvprintw(5,0, "PAN: %f   Tilt: %f           \n", p, t);
#endif 			
		}
	}
	Control::ptControl.SetPosition(0,0);
	cout << "exited from ncurses loop" << endl;
}
