#include "ShowCamWxApp.hh"
#include "ShowCamWxFrame.hh"

using namespace BIAS;
using namespace std;

bool ShowCamWxApp::OnInit()
{
  // Open console for windows
  ConsoleRedirectIO();

  // create main frame
  ShowCamWxFrame *mainFrame;
  mainFrame = new ShowCamWxFrame(AsciiToWx("ShowCamWx"), wxPoint(0,0),
                                 wxSize(400,340));
  
  // read params from file
  mainFrame->InitParams(argc, WxToAsciiArray(argv, argc));

  // necessary for high resolution on small monitors (hackish...)
  mainFrame->SetSizeHints(640,480,1800,1600);

  // initialize cameras and try to open them
  mainFrame->InitCameras();	
  mainFrame->CreateMenu(); 
  
  //check if Pan Tilt Unit is requested and open it 
#ifdef BIAS_HAVE_PanTilt 
  mainFrame->InitPanTiltUnit();
#endif
  mainFrame->ShowParamGUI();
 
  mainFrame->OpenDevices();
 
  // create main windows
  mainFrame->Show(true);
  
  SetTopWindow(mainFrame);
  
  return true;
}

IMPLEMENT_APP(ShowCamWxApp) 
