#include <Image/Camera.hh>
#include <iostream>
#include <Base/Image/ImageIO.hh>
#include <Base/Image/ImageConvert.hh>


using namespace BIAS;
using namespace std;

int main(unsigned int argc, char *argv[])
{
  if (argc<2) {
    cout<<"Usage: biassetrefuuid <image> [<ref-image>]"<<endl;
    exit(1);
  }

  bool SetID=false;
  if (argc>2) SetID=true;

  ImageBase LoadImg,LoadRefImg;
  BIAS::UUID newrefid,oldrefid;
  if (ImageIO::Load(argv[1],LoadImg)<0) exit(1);
  if (SetID) {
    if (ImageIO::Load(argv[2],LoadRefImg)<0) exit(1);;
    newrefid = LoadRefImg.GetUID();
  }

  if (LoadImg.GetStorageType() == ImageBase::ST_float) {
    Camera<float> cam(LoadImg);
    //   cam.SetDebugLevel(D_CAMERA_METADATA);
    cam.ParseMetaData();
    oldrefid = cam.GetReferenceUUID();
    if (SetID) {
      cam.SetReferenceUUID(newrefid);
      cam.UpdateMetaData();
      ImageIO::Write(argv[1],cam);
    }
  }
  
  if (LoadImg.GetStorageType() == ImageBase::ST_unsignedchar) {
    Camera<unsigned char> cam(LoadImg);
    cam.SetDebugLevel(D_CAMERA_METADATA);
    cam.ParseMetaData();
    oldrefid = cam.GetReferenceUUID();
    if (SetID) {
      cam.SetReferenceUUID(newrefid);
      cout <<"Check: "<<cam.GetReferenceUUID()<<endl;
      cam.UpdateMetaData();
      ImageIO::Write(argv[1],cam);
   }
  }
  
  if (SetID) {
    cout <<"Old RefUUID: "<<oldrefid<<endl;
    cout <<"New RefUUID: "<<newrefid<<endl;
  }
  else
    cout <<"Current RefUUID: "<<oldrefid<<endl;
  
  return 0;
}
