
#include "../CameraParameter.hh"

#include <iostream>

using namespace MIP;
using namespace std;

int main(int argc,char** argv){

/*
Very small example of how to use CameraParameter for undistortion.
*/

    double testx,testy;

    // Construct with model name and serial number.
    // (see CameraParameter.hh for known cameras/lenses)
    //CameraParameter cp("SONY EVI-D31","147094",LENS_SONY_EVID31_BUILTIN);
    CameraParameter cp("CAMERA_PTGREY_DRAGONFLY_COLOR","1234XYZ",LENS_PENTAX_CMOUNT_4_8);
    // Set specific zoom
    cp.setZoom(46.5);

    // and get the associated focal length.
    cout << cp.getFocalLength() << endl;

    // When zoom or focal length was set using setZoom() or setFocalLength(),
    // you may now undistort points.
    // Note: Points must be Bougouet-normalized (subtract principal point, then
    //       divide by focal length)

    testx=0.5;
    testy=0.5;

    cp.undistort(testx,testy);

    cout << testx << ", " << testy << endl;

    testx=-0.5;
    testy=-0.5;
    cp.undistort(testx,testy);

    cout << testx << ", " << testy << endl;

    return 0;
}
