#include <MIPVideoSource/VideoSource.hh>
#include <MIPVideoSource/VideoSource_Disk.hh>

#include <MIPCamera/Camera.hh>


int main( int argc, char *argv[])
{
  VideoSource *cam;
  
  Camera<unsigned char> pic;
  
  pic.ImportImage("gerade4_k0_000.pgm");

  cout << "Import OK\n";

  cam = new VideoSource_Disk;

  cam->SetDebuglevel(D_VSO_DISK );

//      cam->ShowCapabilities();

  cam->SetColorModel(MIP_Grey);
    
  cam->OpenDevice("gerade4_k0_",".pgm",3,5);
 
  pic.SetDebugLevel(D_COPYIN | D_CONVERT);
  pic.Init(cam->GetWidth(), cam->GetHeight(), cam->GetColorChannels());
  pic.FillImageWithConstValue((unsigned char)128);
  
  cout << "pic.Init() done with: "<<cam->GetWidth()<<" "<<cam->GetHeight()<<" "<< cam->GetColorChannels()<<endl;
  
  cam->PreGrab();
  for (int i=0; i<10; i++){
    cam->GrabSingle(pic);
    cout <<i<< " Grab() done"<<endl;
  }
  cam->PostGrab();
  cam->CloseDevice();
  
  // pic.IP_ToGrey();
  pic.ExportImage("cam", MIP_pgm);

  delete cam;
  return 0;
}

