#include <VideoSource/VideoSource_usbPMD.hh>
#include <Base/Image/ImageIO.hh>

#include <sstream>

using namespace std;
using namespace BIAS;

int main(int argc, char** argv)
{
  VideoSource_usbPMD cam;

  cam.SetBitFile("C:/Programme/z2D3D/Bitfiles/AchtBitExt.rbt");

  if (cam.OpenDevice() < 0) {
    BIASERR("Error initializing camera!!!");
    abort();
  }
  float shutter = 10.0;
  if (cam.SetShutter(shutter) < 0) {
    BIASERR("Error setting shutter!!!");
    abort();
  }
  else
    cerr<<"SetShutter: "<<shutter<<endl;

  cam.SetShutter2D(30.0);
  cerr<<"SetShutter2D: 30.0"<<endl;

  shutter = cam.GetShutter();
  cerr<<"GetShutter:"<<shutter<<endl;
  shutter = cam.GetShutter2D();
  cerr<<"GetShutter2D:"<<shutter<<endl; 

  Camera<unsigned char> grey;
  Camera<float> depth, coeff;

  stringstream st("");

  int i=0;
  while (i<10) {
    i++;

    //if(cam.CaptureSinglePhase(grey)!=0){
    //  BIASERR("CaptureSinglePhase failed");
    //  return -1;
    //}

    st << "temp" << i << ".mip";
    if (cam.GrabSingle(grey) < 0) {
      BIASERR("Grabbing went wrong!");
      return -1;
    }
    if (cam.GrabSingleDepth(depth) < 0) {
      BIASERR("No depthimage available!!!");
      return -1;
    }
    if (cam.GrabSingleModCoeff(coeff) < 0) {
      BIASERR("No depthimage available!!!");
      return -1;
    }
    ImageIO::Write(st.str(), grey);
    st.str(string(""));
    st << "tempDepth" << i << ".mip";
    ImageIO::Write(st.str(), depth);
    st.str(string(""));
    st << "tempCoeff" << i << ".mip";
    ImageIO::Write(st.str(), coeff);
    st.str(string(""));
  }

  return 0;
}