/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "VideoShMFeederPMD.hh"
#include <Base/Common/BIASpragma.hh>

using namespace BIAS;
using namespace std;

VideoShMFeederPMD::
VideoShMFeederPMD() : VideoShMFeeder()
{}


VideoShMFeederPMD::
VideoShMFeederPMD(const string &filename) : VideoShMFeeder(filename)
{}


VideoShMFeederPMD::~VideoShMFeederPMD() 
{}

 
bool VideoShMFeederPMD::ProcessImage(BIAS::Camera<unsigned char> *Img2D,
                                     BIAS::Camera<float> *ImgDepth,
                                     BIAS::Camera<float> *ImgModCoeff)
{

  ImgBuffer_.clear();
  ImgBuffer_.str("");
  ImgBuffer_ <<*Img2D<<*ImgDepth<<*ImgModCoeff;
  
  int size = ImgBuffer_.str().length();
  if (!bIsInitialized_) {
    DataLength_ = size;
    Init_();
  }
  BIASASSERT(size <=DataLength_);

  Header_->Size_ = DataLength_;
  
  memcpy(Data_,ImgBuffer_.str().c_str() ,Header_->Size_);
  Header_->Time_ = Img2D->GetTime();
//   cout <<"VideoShmFeeder: Header is: "<<setw(20)<<setprecision(20)
//        <<Header_->Time_<<" , "<<Header_->Size_<<endl;

  return true;
}
  
